DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Member Functions | Private Attributes | List of all members
DVPSStoredPrint Class Reference

the representation of a Stored Print object More...

## Public Member Functions
| DVPSStoredPrint (Uint16 illumin, Uint16 reflection, const char *aetitle=NULL)
| constructor More...
| DVPSStoredPrint (const DVPSStoredPrint &copy)
| copy constructor
DVPSStoredPrint * | clone ()
| clone method. More...
virtual | ~DVPSStoredPrint ()
| destructor
void | clear ()
| reset the object to initial state. More...
OFCondition | read (DcmItem &dset)
| reads a Stored Print object from a DICOM dataset. More...
OFCondition | write (DcmItem &dset, OFBool writeRequestedImageSize, OFBool limitImages, OFBool updateDecimateCrop, OFBool ignoreEmptyImages)
| writes the Stored Print object to a DICOM dataset. More...
OFCondition | setOriginator (const char *aetitle)
| sets the name of the current printer. More...
OFCondition | setDestination (const char *aetitle)
| sets the application entity title of the print SCU. More...
OFCondition | setPrinterName (const char *name)
| sets the application entity title of the print SCP. More...
OFCondition | setImageDisplayFormat (unsigned long columns, unsigned long rows)
| sets the image display format to 'STANDARD\columns,rows'. More...
OFCondition | setFilmSizeID (const char *value)
| sets the (optional) film size ID. More...
OFCondition | setMagnificationType (const char *value)
| sets the (optional) magnification type. More...
OFCondition | setSmoothingType (const char *value)
| sets the (optional) smoothing type. More...
OFCondition | setConfigurationInformation (const char *value)
| sets the (optional) configuration information. More...
OFCondition | setResolutionID (const char *value)
| sets the (optional) requested resolution ID. More...
OFCondition | setFilmOrientation (DVPSFilmOrientation value)
| sets the (optional) film orientation. More...
OFCondition | setTrim (DVPSTrimMode value)
| sets the (optional) trim (printing of borders). More...
OFCondition | setRequestedDecimateCropBehaviour (DVPSDecimateCropBehaviour value)
| sets the (optional) requested decimate/crop behaviour for all image boxes managed by this stored print object. More...
OFCondition | setBorderDensity (const char *value)
| sets the (optional) border density. More...
OFCondition | setEmtpyImageDensity (const char *value)
| sets the (optional) empty image density. More...
OFCondition | setMaxDensity (const char *value)
| sets the (optional) max density. More...
OFCondition | setMinDensity (const char *value)
| sets the (optional) min density. More...
OFCondition | newPrinter (const char *name=NULL, const char *destinationAE=NULL)
| deletes all optional attribute values that might not be supported by all printers. More...
const char * | getOriginator ()
| gets the the application entity title of the print SCU. More...
const char * | getDestination ()
| gets the the application entity title of the print SCP. More...
const char * | getPrinterName ()
| gets the name of the current printer. More...
unsigned long | getImageDisplayFormatColumns ()
| gets the number of columns of the current image display format. More...
unsigned long | getImageDisplayFormatRows ()
| gets the number of rows of the current image display format. More...
DVPSFilmOrientation | getFilmOrientation ()
| gets the current film orientation. More...
DVPSTrimMode | getTrim ()
| gets the current trim mode. More...
DVPSDecimateCropBehaviour | getRequestedDecimateCropBehaviour ()
| gets the current requested decimate/crop behaviour setting that is used for all image boxes managed by this object. More...
const char * | getStudyInstanceUID ()
| gets the Study Instance UID. More...
const char * | getSeriesInstanceUID ()
| gets the Series Instance UID. More...
const char * | getSOPInstanceUID ()
| gets the SOP Instance UID. More...
const char * | getFilmSizeID ()
| gets the (optional) film size ID. More...
const char * | getMagnificationType ()
| gets the (optional) magnification type. More...
const char * | getSmoothingType ()
| gets the (optional) smoothing type. More...
const char * | getConfigurationInformation ()
| gets the (optional) configuration information. More...
const char * | getResolutionID ()
| gets the (optional) requested resolution ID More...
const char * | getBorderDensity ()
| gets the (optional) border density. More...
const char * | getEmtpyImageDensity ()
| gets the (optional) empty image density. More...
const char * | getMaxDensity ()
| gets the (optional) max density. More...
const char * | getMinDensity ()
| gets the (optional) min density. More...
Uint16 | getMaxDensityValue ()
| gets the (optional) max density. More...
Uint16 | getMinDensityValue ()
| gets the (optional) min density. More...
size_t | getNumberOfImages ()
| gets the number of images currently registered in this object. More...
size_t | getNumberOfAnnotations ()
| gets the number of annotations currently registered in this object. More...
OFCondition | deleteImage (size_t idx)
| deletes one of the registered images. More...
OFCondition | deleteMultipleImages (size_t number)
| deletes multiple of the registered images, starting with the first one. More...
OFCondition | deleteSpooledImages ()
| deletes as many images as fit on the current page according to the image display format settings. More...
OFBool | imageHasAdditionalSettings (size_t idx)
| checks if one of the registered images has additional settings that are not default values on the image box level. More...
OFCondition | setImagePolarity (size_t idx, const char *value)
| sets the polarity for the given registered image box. More...
OFCondition | setImageRequestedSize (size_t idx, const char *value)
| sets the requested size for the given registered image box. More...
OFCondition | setImageMagnificationType (size_t idx, const char *value)
| sets the (optional) magnification type for the given registered image box. More...
OFCondition | setImageSmoothingType (size_t idx, const char *value)
| sets the (optional) smoothing type for the given registered image box. More...
OFCondition | setImageConfigurationInformation (size_t idx, const char *value)
| sets the (optional) configuration information for the given registered image box. More...
const char * | getImagePolarity (size_t idx)
| gets the polarity for the given registered image box. More...
const char * | getImageRequestedSize (size_t idx)
| gets the requested size for the given registered image box. More...
const char * | getImageMagnificationType (size_t idx)
| gets the (optional) magnification type for the given registered image box. More...
const char * | getImageSmoothingType (size_t idx)
| gets the (optional) smoothing type for the given registered image box. More...
const char * | getImageConfigurationInformation (size_t idx)
| gets the (optional) configuration information for the given registered image box. More...
DVPSPresentationLUT * | getImagePresentationLUT (size_t idx)
| gets the presentation LUT for the given registered image box. More...
DVPSPresentationLUT * | getPresentationLUT ()
| gets the "global" presentation LUT which overrides the settings for the image boxes. More...
OFCondition | setDefaultPresentationLUT ()
| resets the Presentation LUT to the default setting. More...
OFCondition | setPresentationLUTShape (DVPSPresentationLUTType shape)
| sets the current Presentation LUT shape (overrides the image box settings). More...
OFCondition | setPresentationLookupTable (DcmItem &dset)
| stores a presentation lookup table in the stored print object. More...
Sint32 | convertODtoPValue (Uint16 density, unsigned int bits=8)
| converts an optical density (OD) value to an 8/12/16-bit P-value which is linear to luminance. More...
OFCondition | writeHardcopyImageAttributes (DcmItem &dset)
| writes the general study and series module attributes for a grayscale hardcopy image that is related to this stored print object to a DICOM dataset. More...
OFCondition | addImageBox (const char *retrieveaetitle, const char *refstudyuid, const char *refseriesuid, const char *refsopclassuid, const char *refsopinstanceuid, const char *requestedimagesize, const char *patientid, DVPSPresentationLUT *presentationlut, OFBool inversePLUT)
| creates a new image box object and sets the content of this image box object. More...
OFCondition | addImageBox (const char *retrieveaetitle, const char *refsopinstanceuid, const char *requestedimagesize=NULL, const char *patientid=NULL, DVPSPresentationLUT *presentationlut=NULL, OFBool inversePLUT=OFFalse)
| creates a new image box object and sets the content of this image box object. More...
OFCondition | setSingleAnnotation (const char *displayformat, const char *text, Uint16 position)
| deletes all existing annotations and creates a new one, with given text and position. More...
void | deleteAnnotations ()
| deletes all annotations, clears annotation display format.
OFCondition | setInstanceUID (const char *uid)
| sets a new SOP Instance UID for the Stored Print object. More...
void | clearInstanceUID ()
| clears the SOP instance UID for the Stored Print object. More...
OFCondition | getImageReference (size_t idx, const char *&studyUID, const char *&seriesUID, const char *&instanceUID)
| returns the image UIDs that are required to look up the referenced image in the database More...
DVPSPrintPresentationLUTAlignment | getReferencedPresentationLUTAlignment ()
| returns a description of the currently activated Presentation LUT (if any) in terms of the Presentation LUT matching rule (see description of enum type for details). More...
OFCondition | printSCUgetPrinterInstance (DVPSPrintMessageHandler &printHandler)
| Requests the properties of the printer (Printer SOP Instance N-GET). More...
OFCondition | printSCUpreparePresentationLUT (DVPSPrintMessageHandler &printHandler, OFBool printerRequiresMatchingLUT, OFBool printerLUTRenderingPreferred, OFBool printerSupports12Bit)
| checks whether a presentation LUT or LUT shape is active in this stored print object. More...
OFCondition | printSCUcreateBasicFilmSession (DVPSPrintMessageHandler &printHandler, DcmDataset &dset, OFBool plutInSession)
| Creates a DICOM Basic Film Session SOP Instance in the printer. More...
OFCondition | printSCUcreateBasicFilmBox (DVPSPrintMessageHandler &printHandler, OFBool plutInSession)
| Creates a DICOM Basic Film Box SOP Instance in the printer. More...
OFCondition | printSCUsetBasicImageBox (DVPSPrintMessageHandler &printHandler, size_t idx, DicomImage &image, OFBool useMonochrome1=OFFalse)
| Transmits a DICOM image to the printer (Basic Grayscale Image Box N-SET). More...
OFCondition | printSCUsetBasicAnnotationBox (DVPSPrintMessageHandler &printHandler, size_t idx)
| Transmits a DICOM annotation to the printer (Basic Annotation Box N-SET). More...
OFCondition | printSCUprintBasicFilmBox (DVPSPrintMessageHandler &printHandler)
| Prints the current DICOM Basic Film Box SOP Instance. More...
OFCondition | printSCUprintBasicFilmSession (DVPSPrintMessageHandler &printHandler)
| Prints the current DICOM Basic Film Session. More...
OFCondition | printSCUdelete (DVPSPrintMessageHandler &printHandler)
| Deletes all objects currently present in the print association. More...
OFCondition | setPrintIllumination (Uint16 value)
| sets the illumination to be used with the print Presentation LUT SOP Class. More...
Uint16 | getPrintIllumination ()
| gets the current illumination setting used with the print Presentation LUT SOP Class. More...
OFCondition | setPrintReflectedAmbientLight (Uint16 value)
| sets the reflected ambient light to be used with the print Presentation LUT SOP Class. More...
Uint16 | getPrintReflectedAmbientLight ()
| gets the current reflected ambient light setting used with the print Presentation LUT SOP Class. More...
OFBool | printSCPCreate (DVConfiguration &cfg, const char *cfgname, DcmDataset *rqDataset, T_DIMSE_Message &rsp, DcmDataset *&rspDataset, OFBool presentationLUTnegotiated, DVPSPresentationLUT_PList &globalPresentationLUTList, const char *filmSessionUID, DcmUniqueIdentifier &study, DcmUniqueIdentifier &psSeries, DcmUniqueIdentifier &imgSeries)
| performs a Print SCP Basic Film Box N-CREATE operation on a newly created instance of this class. More...
OFBool | printSCPSet (DVConfiguration &cfg, const char *cfgname, DcmDataset *rqDataset, T_DIMSE_Message &rsp, DcmDataset *&rspDataset, OFBool presentationLUTnegotiated, DVPSPresentationLUT_PList &globalPresentationLUTList)
| performs a Print SCP Basic Film Box N-SET operation on an instance of this class. More...
OFBool | isFilmBoxInstance (const char *c)
| checks whether the given UID string matches the film box UID. More...
OFBool | usesPresentationLUT (const char *c)
| checks whether the Presentation LUT with the given UID is referenced by this Stored Print object on the film box level. More...
DVPSImageBoxContent * | duplicateImageBox (const char *uid)
| looks up the image box with the given SOP instance UID in the image box list and returns a pointer to a new object containing a copy of this image box. More...
OFBool | haveImagePositionClash (const char *uid, Uint16 position)
| checks whether any of the image boxes managed by the image box list has the same position as the given one, but a different SOP instance UID. More...
void | replaceImageBox (DVPSImageBoxContent *newImageBox)
| adds the given image box object to the image box list. More...
void | updatePresentationLUTList (DVPSPresentationLUT_PList &globalPresentationLUTList)
| updates the list of Presentation LUTs managed by the Stored Print object from a global list. More...
OFBool | matchesPresentationLUT (DVPSPrintPresentationLUTAlignment align) const
| checks whether the given Presentation LUT type could be used together with all image boxes in this film box on a Print SCP that requires a matching alignment between a Presentation LUT and the image pixel data. More...
void | overridePresentationLUTSettings (DcmUnsignedShort &newIllumination, DcmUnsignedShort &newReflectedAmbientLight, DcmUniqueIdentifier &newReferencedPLUT, DVPSPrintPresentationLUTAlignment newAlignment)
| replaces the settings for illumination, reflected ambient light and referenced Presentation LUT in this film box. More...
OFBool | emptyPageWarning ()
| checks whether any of the image boxes has an image box position assigned. More...

## Private Member Functions
DVPSStoredPrint & | operator= (const DVPSStoredPrint &)
| private undefined assignment operator
OFCondition | createDefaultValues ()
| create default values for all missing type 1 elements. More...
OFCondition | addReferencedPLUTSQ (DcmItem &dset)
| writes a Referenced Presentation LUT SQ to the given dataset. More...
OFCondition | addPresentationLUTReference (DcmItem &dset)
| writes a Referenced Presentation LUT SQ, Illumination and reflected ambient light to the given dataset. More...
void | invalidateCache ()
| invalidates the cached number of columns and rows
void | updateCache ()
| updates the cached number of columns and rows

## Private Attributes
DcmPersonName | patientName
| Module=Patient, VR=PN, VM=1, Type 1.
DcmLongString | patientID
| Module=Patient, VR=LO, VM=1, Type 2.
DcmDate | patientBirthDate
| Module=Patient, VR=DA, VM=1, Type 2.
DcmCodeString | patientSex
| Module=Patient, VR=CS, VM=1, Type 2.
DcmUniqueIdentifier | studyInstanceUID
| Module=General_Study, VR=UI, VM=1, Type 1.
DcmDate | studyDate
| Module=General_Study, VR=DA, VM=1, Type 2.
DcmTime | studyTime
| Module=General_Study, VR=TM, VM=1, Type 2.
DcmPersonName | referringPhysicianName
| Module=General_Study, VR=PN, VM=1, Type 2.
DcmShortString | studyID
| Module=General_Study, VR=SH, VM=1, Type 2.
DcmShortString | accessionNumber
| Module=General_Study, VR=SH, VM=1, Type 2.
DcmUniqueIdentifier | seriesInstanceUID
| Module=General_Series, VR=UI, VM=1, Type 1.
DcmIntegerString | seriesNumber
| Module=General_Series, VR=IS, VM=1, Type 2.
DcmLongString | manufacturer
| Module=General_Equipment, VR=LO, VM=1, Type 2.
DcmApplicationEntity | originator
| Module=Printer_Characteristics_Module, VR=AE, VM=1, Type 2.
DcmApplicationEntity | destination
| Module=Printer_Characteristics_Module, VR=AE, VM=1, Type 2.
DcmLongString | printerName
| Module=Printer_Characteristics_Module, VR=LO, VM=1, Type 3.
DcmIntegerString | instanceNumber
| Module=Film_Box_Module, VR=IS, VM=1, Type 2.
DcmShortText | imageDisplayFormat
| Module=Film_Box_Module, VR=ST, VM=1, Type 1.
DcmCodeString | annotationDisplayFormatID
| Module=Film_Box_Module, VR=CS, VM=1, Type 3.
DcmCodeString | filmOrientation
| Module=Film_Box_Module, VR=CS, VM=1, Type 2.
DcmCodeString | filmSizeID
| Module=Film_Box_Module, VR=CS, VM=1, Type 2.
DcmCodeString | magnificationType
| Module=Film_Box_Module, VR=CS, VM=1, Type 2.
DcmCodeString | smoothingType
| Module=Film_Box_Module, VR=CS, VM=1, Type 3.
DcmCodeString | borderDensity
| Module=Film_Box_Module, VR=CS, VM=1, Type 3.
DcmCodeString | emptyImageDensity
| Module=Film_Box_Module, VR=CS, VM=1, Type 3.
DcmUnsignedShort | minDensity
| Module=Film_Box_Module, VR=US, VM=1, Type 3.
DcmUnsignedShort | maxDensity
| Module=Film_Box_Module, VR=US, VM=1, Type 2.
DcmCodeString | trim
| Module=Film_Box_Module, VR=CS, VM=1, Type 3.
DcmShortText | configurationInformation
| Module=Film_Box_Module, VR=ST, VM=1, Type 2.
DcmUnsignedShort | illumination
| Module=Film_Box_Module, VR=US, VM=1, Type 2c required if presentation SOP class present.
DcmUnsignedShort | reflectedAmbientLight
| Module=Film_Box_Module, VR=US, VM=1, Type 2c required if presentation SOP class present.
DcmCodeString | requestedResolutionID
| Module=Film_Box_Module (Supplement 38), VR=CS, VM=1, Type 3.
DcmUniqueIdentifier | referencedPresentationLUTInstanceUID
| the ReferencedPresentationLUTSequence is only created/read on the fly
DVPSPrintPresentationLUTAlignment | referencedPresentationLUTAlignment
| The Print SCP can be configured to enforce a rule requiring that the number of entries in a Presentation LUT matches the bit depth of the image pixel data. More...
DVPSImageBoxContent_PList | imageBoxContentList
| Module=Image_Box_List_Module, VR=SQ, VM=1, Type 1.
DVPSAnnotationContent_PList | annotationContentList
| Module=Annotation_List_Module, VR=SQ, VM=1, Type 3.
DcmUniqueIdentifier | sOPInstanceUID
| Module=SOP_Common, VR=UI, VM=1, Type 1.
DcmCodeString | specificCharacterSet
| Module=SOP_Common, VR=CS, VM=1-n, Type 1C.
DcmDate | instanceCreationDate
| Module=SOP_Common, VR=DA, VM=1, Type 3.
DcmTime | instanceCreationTime
| Module=SOP_Common, VR=TM, VM=1, Type 3.
DcmUniqueIdentifier | imageSeriesInstanceUID
| used when creating hardcopy image objects
OFBool | currentValuesValid
| flag indicating whether the currentXX values are up to date
unsigned long | currentNumCols
| current number of columns
unsigned long | currentNumRows
| current number of rows
DVPSDecimateCropBehaviour | decimateCropBehaviour
| requested decimate/crop behaviour used in all image boxes
OFString | filmSessionInstanceUID
| the current film session instance
OFString | filmBoxInstanceUID
| the current film box instance
OFString | presentationLUTInstanceUID
| the current presentation LUT instance. More...
DVPSPresentationLUT | globalPresentationLUT
| stores the "global" presentation LUT that overrides the image box LUTs (optional)
OFBool | globalPresentationLUTValid
| flag indicating whether the globalPresentationLUT is currently valid or not
OFBool | transmitImagesIn12Bit
| transmit images in 12 bit for the current print job
OFBool | renderPresentationLUTinSCP
| presentation LUTs are rendered on SCP side
OFString | tempDensity
| temporary buffer for getMaxDensity and getMinDensity

## Detailed Description

the representation of a Stored Print object

## Constructor & Destructor Documentation

## ◆ DVPSStoredPrint()

DVPSStoredPrint::DVPSStoredPrint | ( | Uint16 | illumin,
|  | Uint16 | reflection,
|  | const char * | aetitle = `NULL`
| ) |  |

constructor

Parameters

  illumin | default Illumination setting
  reflection | default Reflected Ambient Light setting
  aetitle | application entity title of the print originator (SCU)

## Member Function Documentation

## ◆ addImageBox() [1/2]

OFCondition DVPSStoredPrint::addImageBox | ( | const char * | retrieveaetitle,
|  | const char * | refsopinstanceuid,
|  | const char * | requestedimagesize = `NULL`,
|  | const char * | patientid = `NULL`,
|  | DVPSPresentationLUT * | presentationlut = `NULL`,
|  | OFBool | inversePLUT = `OFFalse`
| ) |  |

creates a new image box object and sets the content of this image box object.

This is a specialized version of the method with the same name and more parameters. SOP Class is assumed to be Grayscale Hardcopy, Study and Series are derived from the Stored Print internal defaults.

Parameters

  retrieveaetitle | retrieve AETITLE of the referenced image
  refsopinstanceuid | SOP instance UID of the referenced image
  requestedimagesize | requested images size for this image, default: absent
  patientid | patient ID for the referenced image, default: absent
  presentationlut | presentation LUT to be used, may be NULL (absent)
  inversePLUT | true if presentation LUT is for Monochrome1 and must be inversed.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ addImageBox() [2/2]

OFCondition DVPSStoredPrint::addImageBox | ( | const char * | retrieveaetitle,
|  | const char * | refstudyuid,
|  | const char * | refseriesuid,
|  | const char * | refsopclassuid,
|  | const char * | refsopinstanceuid,
|  | const char * | requestedimagesize,
|  | const char * | patientid,
|  | DVPSPresentationLUT * | presentationlut,
|  | OFBool | inversePLUT
| ) |  |

creates a new image box object and sets the content of this image box object.

Parameters

  retrieveaetitle | retrieve AETITLE of the referenced image
  refstudyuid | Study instance UID of the referenced image
  refseriesuid | Series instance UID of the referenced image
  refsopclassuid | SOP Class UID of the referenced image
  refsopinstanceuid | SOP instance UID of the referenced image
  requestedimagesize | requested images size for this image, may be NULL (absent)
  patientid | patient ID for the referenced image, may be NULL (absent)
  presentationlut | presentation LUT to be used, may be NULL (absent)
  inversePLUT | true if presentation LUT is for Monochrome1 and must be inversed.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ addPresentationLUTReference()

OFCondition DVPSStoredPrint::addPresentationLUTReference | ( | DcmItem & | dset | ) |
| private

writes a Referenced Presentation LUT SQ, Illumination and reflected ambient light to the given dataset.

Helper function used when creating Basic Film Session or Basic Film Box.

Parameters

  dset | the dataset to which the data is written

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ addReferencedPLUTSQ()

OFCondition DVPSStoredPrint::addReferencedPLUTSQ | ( | DcmItem & | dset | ) |
| private

writes a Referenced Presentation LUT SQ to the given dataset.

Helper function used in the more general write() method.

Parameters

  dset | the dataset to which the data is written

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ clear()

void DVPSStoredPrint::clear | ( |  | ) |

reset the object to initial state.

After this call, the object is in the same state as after creation with the default constructor.

## ◆ clearInstanceUID()

void DVPSStoredPrint::clearInstanceUID | ( |  | ) |
| inline

clears the SOP instance UID for the Stored Print object.

a new UID is assigned automatically when writing the object.

## ◆ clone()

DVPSStoredPrint* DVPSStoredPrint::clone | ( |  | ) |
| inline

clone method.

Returns
  a pointer to a new DVPSStoredPrint object containing a copy of this object.

## ◆ convertODtoPValue()

Sint32 DVPSStoredPrint::convertODtoPValue | ( | Uint16 | density,
|  | unsigned int | bits = `8`
| ) |  |

converts an optical density (OD) value to an 8/12/16-bit P-value which is linear to luminance.

The output is not calibrated according to the GSDF. This can be done by convertPValueToDDL() in class DVPSPresentationState. The attributes illumination, reflected ambient light and min/max density (default 20/300) from this stored print object are used for the calculation.

Parameters

  density | in hundreds of OD (e.g. 150 corressponds to 1.5 OD)
  bits | number of bits used for the output value (8, 12, 16)

Returns
  P-Value, 0..0xFF, 0..0xFFF, 0..0xFFFF, < 0 if an error occurred.

## ◆ createDefaultValues()

OFCondition DVPSStoredPrint::createDefaultValues | ( |  | ) |
| private

create default values for all missing type 1 elements.

Called before a stored print object is written.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ deleteImage()

OFCondition DVPSStoredPrint::deleteImage | ( | size_t | idx | ) |

deletes one of the registered images.

Parameters

  idx | index, must be < getNumberOfImages()

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ deleteMultipleImages()

OFCondition DVPSStoredPrint::deleteMultipleImages | ( | size_t | number | ) |

deletes multiple of the registered images, starting with the first one.

Parameters

  number | number of images to delete, must be <= getNumberOfImages()

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ deleteSpooledImages()

OFCondition DVPSStoredPrint::deleteSpooledImages | ( |  | ) |

deletes as many images as fit on the current page according to the image display format settings.

Used to remove images from the queue after a print job with one film box has been spooled.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ duplicateImageBox()

DVPSImageBoxContent* DVPSStoredPrint::duplicateImageBox | ( | const char * | uid | ) |
| inline

looks up the image box with the given SOP instance UID in the image box list and returns a pointer to a new object containing a copy of this image box.

If the object is not found, NULL is returned.

Parameters

  uid | SOP instance UID of the image box to be looked up

Returns
  pointer to copied image box object, may be NULL.

## ◆ emptyPageWarning()

OFBool DVPSStoredPrint::emptyPageWarning | ( |  | ) |
| inline

checks whether any of the image boxes has an image box position assigned.

If no image box position is assigned, the stored print object cannot be written and a Print SCP should return a warning status upon receipt of an N-ACTION request.

Returns
  OFTrue if empty page (no image box position assigned), OFFalse otherwise.

## ◆ getBorderDensity()

const char* DVPSStoredPrint::getBorderDensity | ( |  | ) |

gets the (optional) border density.

Returns
  border density, may be NULL.

## ◆ getConfigurationInformation()

const char* DVPSStoredPrint::getConfigurationInformation | ( |  | ) |

gets the (optional) configuration information.

Returns
  configuration information, may be NULL.

## ◆ getDestination()

const char* DVPSStoredPrint::getDestination | ( |  | ) |

gets the the application entity title of the print SCP.

Returns
  application entity title of the print SCP

## ◆ getEmtpyImageDensity()

const char* DVPSStoredPrint::getEmtpyImageDensity | ( |  | ) |

gets the (optional) empty image density.

Returns
  empty image density, may be NULL.

## ◆ getFilmOrientation()

DVPSFilmOrientation DVPSStoredPrint::getFilmOrientation | ( |  | ) |

gets the current film orientation.

Returns
  film orientation.

## ◆ getFilmSizeID()

const char* DVPSStoredPrint::getFilmSizeID | ( |  | ) |

gets the (optional) film size ID.

Returns
  film size ID, may be NULL.

## ◆ getImageConfigurationInformation()

const char* DVPSStoredPrint::getImageConfigurationInformation | ( | size_t | idx | ) |
| inline

gets the (optional) configuration information for the given registered image box.

Parameters

  idx | index, must be < getNumberOfImages()

Returns
  configuration information, may be NULL.

## ◆ getImageDisplayFormatColumns()

unsigned long DVPSStoredPrint::getImageDisplayFormatColumns | ( |  | ) |

gets the number of columns of the current image display format.

Returns
  number of columns.

## ◆ getImageDisplayFormatRows()

unsigned long DVPSStoredPrint::getImageDisplayFormatRows | ( |  | ) |

gets the number of rows of the current image display format.

Returns
  number of rows.

## ◆ getImageMagnificationType()

const char* DVPSStoredPrint::getImageMagnificationType | ( | size_t | idx | ) |
| inline

gets the (optional) magnification type for the given registered image box.

Parameters

  idx | index, must be < getNumberOfImages()

Returns
  magnification type, may be NULL.

## ◆ getImagePolarity()

const char* DVPSStoredPrint::getImagePolarity | ( | size_t | idx | ) |
| inline

gets the polarity for the given registered image box.

Parameters

  idx | index, must be < getNumberOfImages()

Returns
  polarity (NORMAL or REVERSE), may be NULL.

## ◆ getImagePresentationLUT()

DVPSPresentationLUT* DVPSStoredPrint::getImagePresentationLUT | ( | size_t | idx | ) |

gets the presentation LUT for the given registered image box.

If not available the presentation LUT of the film box is used.

Parameters

  idx | index, must be < getNumberOfImages()

Returns
  pointer to presentation LUT, may be NULL.

## ◆ getImageReference()

OFCondition DVPSStoredPrint::getImageReference | ( | size_t | idx,
|  | const char *& | studyUID,
|  | const char *& | seriesUID,
|  | const char *& | instanceUID
| ) |  |
| inline

returns the image UIDs that are required to look up the referenced image in the database

Parameters

  idx | index, must be < getNumberOfImages()
  studyUID | Study UID of the image
  seriesUID | series UID of the image
  instanceUID | instance UID of the image

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ getImageRequestedSize()

const char* DVPSStoredPrint::getImageRequestedSize | ( | size_t | idx | ) |
| inline

gets the requested size for the given registered image box.

Parameters

  idx | index, must be < getNumberOfImages()

Returns
  requested size (in mm), may be NULL.

## ◆ getImageSmoothingType()

const char* DVPSStoredPrint::getImageSmoothingType | ( | size_t | idx | ) |
| inline

gets the (optional) smoothing type for the given registered image box.

Parameters

  idx | index, must be < getNumberOfImages()

Returns
  smoothing type, may be NULL.

## ◆ getMagnificationType()

const char* DVPSStoredPrint::getMagnificationType | ( |  | ) |

gets the (optional) magnification type.

Returns
  magnification type, may be NULL.

## ◆ getMaxDensity()

const char* DVPSStoredPrint::getMaxDensity | ( |  | ) |

gets the (optional) max density.

The string returned becomes invalid after the next call to getMaxDensity or getMinDensity.

Returns
  max density, may be NULL.

## ◆ getMaxDensityValue()

Uint16 DVPSStoredPrint::getMaxDensityValue | ( |  | ) |

gets the (optional) max density.

Returns
  max density (default: 300).

## ◆ getMinDensity()

const char* DVPSStoredPrint::getMinDensity | ( |  | ) |

gets the (optional) min density.

The string returned becomes invalid after the next call to getMaxDensity or getMinDensity.

Returns
  min density, may be NULL.

## ◆ getMinDensityValue()

Uint16 DVPSStoredPrint::getMinDensityValue | ( |  | ) |

gets the (optional) min density.

Returns
  min density (default: 20).

## ◆ getNumberOfAnnotations()

size_t DVPSStoredPrint::getNumberOfAnnotations | ( |  | ) |
| inline

gets the number of annotations currently registered in this object.

Returns
  number of annotations.

## ◆ getNumberOfImages()

size_t DVPSStoredPrint::getNumberOfImages | ( |  | ) |
| inline

gets the number of images currently registered in this object.

Returns
  number of images.

## ◆ getOriginator()

const char* DVPSStoredPrint::getOriginator | ( |  | ) |

gets the the application entity title of the print SCU.

Returns
  application entity title of the print SCP

## ◆ getPresentationLUT()

DVPSPresentationLUT* DVPSStoredPrint::getPresentationLUT | ( |  | ) |

gets the "global" presentation LUT which overrides the settings for the image boxes.

If not available the presentation LUT of the image box is used.

Returns
  pointer to presentation LUT, may be NULL.

## ◆ getPrinterName()

const char* DVPSStoredPrint::getPrinterName | ( |  | ) |

gets the name of the current printer.

Returns
  name of the current printer

## ◆ getPrintIllumination()

Uint16 DVPSStoredPrint::getPrintIllumination | ( |  | ) |

gets the current illumination setting used with the print Presentation LUT SOP Class.

Returns
  illumination in cd/m2

## ◆ getPrintReflectedAmbientLight()

Uint16 DVPSStoredPrint::getPrintReflectedAmbientLight | ( |  | ) |

gets the current reflected ambient light setting used with the print Presentation LUT SOP Class.

Returns
  reflected ambient light in cd/m2

## ◆ getReferencedPresentationLUTAlignment()

DVPSPrintPresentationLUTAlignment DVPSStoredPrint::getReferencedPresentationLUTAlignment | ( |  | ) |
| inline

returns a description of the currently activated Presentation LUT (if any) in terms of the Presentation LUT matching rule (see description of enum type for details).

Returns
  Presentation LUT alignment

## ◆ getRequestedDecimateCropBehaviour()

DVPSDecimateCropBehaviour DVPSStoredPrint::getRequestedDecimateCropBehaviour | ( |  | ) |
| inline

gets the current requested decimate/crop behaviour setting that is used for all image boxes managed by this object.

Returns
  requested decimate/crop behaviour

## ◆ getResolutionID()

const char* DVPSStoredPrint::getResolutionID | ( |  | ) |

gets the (optional) requested resolution ID

Returns
  requested resolution ID, may be NULL.

## ◆ getSeriesInstanceUID()

const char* DVPSStoredPrint::getSeriesInstanceUID | ( |  | ) |

gets the Series Instance UID.

Returns
  Series Instance UID, may be NULL.

## ◆ getSmoothingType()

const char* DVPSStoredPrint::getSmoothingType | ( |  | ) |

gets the (optional) smoothing type.

Returns
  smoothing type, may be NULL.

## ◆ getSOPInstanceUID()

const char* DVPSStoredPrint::getSOPInstanceUID | ( |  | ) |

gets the SOP Instance UID.

Returns
  SOP Instance UID, may be NULL.

## ◆ getStudyInstanceUID()

const char* DVPSStoredPrint::getStudyInstanceUID | ( |  | ) |

gets the Study Instance UID.

Returns
  Study Instance UID, may be NULL.

## ◆ getTrim()

DVPSTrimMode DVPSStoredPrint::getTrim | ( |  | ) |

gets the current trim mode.

Returns
  trim mode.

## ◆ haveImagePositionClash()

OFBool DVPSStoredPrint::haveImagePositionClash | ( | const char * | uid,
|  | Uint16 | position
| ) |  |
| inline

checks whether any of the image boxes managed by the image box list has the same position as the given one, but a different SOP instance UID.

This is used during a Print SCP basic grayscale image box N-SET operation to check whether an image position clash exists.

Parameters

  uid | SOP instance UID of the image box to be looked up
  position | image position to be looked up

## ◆ imageHasAdditionalSettings()

OFBool DVPSStoredPrint::imageHasAdditionalSettings | ( | size_t | idx | ) |
| inline

checks if one of the registered images has additional settings that are not default values on the image box level.

Parameters

  idx | index, must be < getNumberOfImages()

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ isFilmBoxInstance()

OFBool DVPSStoredPrint::isFilmBoxInstance | ( | const char * | c | ) |
| inline

checks whether the given UID string matches the film box UID.

Parameters

  c | uid to be compared

Returns
  OFTrue if equal, OFFalse otherwise

## ◆ matchesPresentationLUT()

OFBool DVPSStoredPrint::matchesPresentationLUT | ( | DVPSPrintPresentationLUTAlignment | align | ) | const
| inline

checks whether the given Presentation LUT type could be used together with all image boxes in this film box on a Print SCP that requires a matching alignment between a Presentation LUT and the image pixel data.

Parameters

  align | LUT alignment type

Returns
  OFTrue if matching, OFFalse otherwise

## ◆ newPrinter()

OFCondition DVPSStoredPrint::newPrinter | ( | const char * | name = `NULL`,
|  | const char * | destinationAE = `NULL`
| ) |  |

deletes all optional attribute values that might not be supported by all printers.

Film size ID, magnification and smoothing type, configuration information, requested resolution ID, trim and requested decimate/crop behaviour, border and empty image density are reset to default. For all registered images, magnification, smoothing type and configuration information are also set back to default.

Parameters

  name | name of the new printer (optional)
  destinationAE | aetitle of the new printer (optional)

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ overridePresentationLUTSettings()

void DVPSStoredPrint::overridePresentationLUTSettings | ( | DcmUnsignedShort & | newIllumination,
|  | DcmUnsignedShort & | newReflectedAmbientLight,
|  | DcmUniqueIdentifier & | newReferencedPLUT,
|  | DVPSPrintPresentationLUTAlignment | newAlignment
| ) |  |

replaces the settings for illumination, reflected ambient light and referenced Presentation LUT in this film box.

Used by a Print SCP if Presentation LUT is implemented on Film Session level.

Parameters

  newIllumination | new value for illumination
  newReflectedAmbientLight | new value for reflectedAmbientLight
  newReferencedPLUT | new value for referenced presentation LUT instance UID
  newAlignment | new alignment type of active presentation LUT

## ◆ printSCPCreate()

OFBool DVPSStoredPrint::printSCPCreate | ( | DVConfiguration & | cfg,
|  | const char * | cfgname,
|  | DcmDataset * | rqDataset,
|  | T_DIMSE_Message & | rsp,
|  | DcmDataset *& | rspDataset,
|  | OFBool | presentationLUTnegotiated,
|  | DVPSPresentationLUT_PList & | globalPresentationLUTList,
|  | const char * | filmSessionUID,
|  | DcmUniqueIdentifier & | study,
|  | DcmUniqueIdentifier & | psSeries,
|  | DcmUniqueIdentifier & | imgSeries
| ) |  |

performs a Print SCP Basic Film Box N-CREATE operation on a newly created instance of this class.

The results of the operation are stored in the objects passed as rsp, rspDataset and globalPresentationLUTList.

Parameters

  cfg | config file facility
  cfgname | symbolic printer name in config file
  rqDataset | N-CREATE request dataset, may be NULL
  rsp | N-CREATE response message
  rspDataset | N-CREATE response dataset passed back in this parameter
  presentationLUTnegotiated | OFTrue if support for the Presentation LUT SOP class has been negotiated at association negotiation and is supported on Basic Film Box level
  globalPresentationLUTList | list of presentation LUTs managed by the Print SCP. If a SCP default Presentation LUT needs to be created as the result of the N-CREATE operation, it is stored in this list.
  filmSessionUID | SOP instance UID of the Basic Film Session object
  study | study UID to be used when storing Stored Print or image objects
  psSeries | series UID to be used when storing Stored Print objects
  imgSeries | series UID to be used when storing image objects (Hardcopy Grayscale)

Returns
  OFTrue if N-CREATE was successful, OFFalse otherwise.

## ◆ printSCPSet()

OFBool DVPSStoredPrint::printSCPSet | ( | DVConfiguration & | cfg,
|  | const char * | cfgname,
|  | DcmDataset * | rqDataset,
|  | T_DIMSE_Message & | rsp,
|  | DcmDataset *& | rspDataset,
|  | OFBool | presentationLUTnegotiated,
|  | DVPSPresentationLUT_PList & | globalPresentationLUTList
| ) |  |

performs a Print SCP Basic Film Box N-SET operation on an instance of this class.

The results of the N-SET operation are stored in the objects passed as rsp and rspDataset.

Parameters

  cfg | config file facility
  cfgname | symbolic printer name in config file
  rqDataset | N-SET request dataset
  rsp | N-SET response message
  rspDataset | N-SET response dataset passed back in this parameter
  presentationLUTnegotiated | OFTrue if support for the Presentation LUT SOP class has been negotiated at association negotiation and is supported on Basic Film Box level
  globalPresentationLUTList | list of presentation LUTs managed by the Print SCP

Returns
  OFTrue if N-SET was successful, OFFalse otherwise.

## ◆ printSCUcreateBasicFilmBox()

OFCondition DVPSStoredPrint::printSCUcreateBasicFilmBox | ( | DVPSPrintMessageHandler & | printHandler,
|  | OFBool | plutInSession
| ) |  |

Creates a DICOM Basic Film Box SOP Instance in the printer.

This method only allows one basic film box to exist at any time - collation is not supported.

Parameters

  printHandler | print communication handler, association must be open.
  plutInSession | true if printer expects referenced presentation LUT sequence, illumination and reflected ambient light in basic film session, false if it expects them in basic film box.

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ printSCUcreateBasicFilmSession()

OFCondition DVPSStoredPrint::printSCUcreateBasicFilmSession | ( | DVPSPrintMessageHandler & | printHandler,
|  | DcmDataset & | dset,
|  | OFBool | plutInSession
| ) |  |

Creates a DICOM Basic Film Session SOP Instance in the printer.

Parameters

  printHandler | print communication handler, association must be open.
  dset | DICOM dataset containing all Basic Film Session attributes managed outside this class
  plutInSession | true if printer expects referenced presentation LUT sequence, illumination and reflected ambient light in basic film session, false if it expects them in basic film box.

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ printSCUdelete()

OFCondition DVPSStoredPrint::printSCUdelete | ( | DVPSPrintMessageHandler & | printHandler | ) |

Deletes all objects currently present in the print association.

Parameters

  printHandler | print communication handler, association must be open.

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ printSCUgetPrinterInstance()

OFCondition DVPSStoredPrint::printSCUgetPrinterInstance | ( | DVPSPrintMessageHandler & | printHandler | ) |

Requests the properties of the printer (Printer SOP Instance N-GET).

The properties are not returned, but if the message handler is switched to "dump mode", the DIMSE communication will be printed.

Parameters

  printHandler | print communication handler, association must be open.

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ printSCUpreparePresentationLUT()

OFCondition DVPSStoredPrint::printSCUpreparePresentationLUT | ( | DVPSPrintMessageHandler & | printHandler,
|  | OFBool | printerRequiresMatchingLUT,
|  | OFBool | printerLUTRenderingPreferred,
|  | OFBool | printerSupports12Bit
| ) |  |

checks whether a presentation LUT or LUT shape is active in this stored print object.

In this case, if the printer supports the Presentation LUT SOP class, a Presentation LUT SOP Instance is created in the printer.

Parameters

  printHandler | print communication handler, association must be open.
  printerRequiresMatchingLUT | true if printer requires presentation LUTs matching the image depth
  printerLUTRenderingPreferred | true if SCP side presentation LUTs should be preferred even if printer supports 12-bit image transmission.
  printerSupports12Bit | true if printer supports 12 bit transmission

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ printSCUprintBasicFilmBox()

OFCondition DVPSStoredPrint::printSCUprintBasicFilmBox | ( | DVPSPrintMessageHandler & | printHandler | ) |

Prints the current DICOM Basic Film Box SOP Instance.

Parameters

  printHandler | print communication handler, association must be open.

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ printSCUprintBasicFilmSession()

OFCondition DVPSStoredPrint::printSCUprintBasicFilmSession | ( | DVPSPrintMessageHandler & | printHandler | ) |

Prints the current DICOM Basic Film Session.

Parameters

  printHandler | print communication handler, association must be open.

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ printSCUsetBasicAnnotationBox()

OFCondition DVPSStoredPrint::printSCUsetBasicAnnotationBox | ( | DVPSPrintMessageHandler & | printHandler,
|  | size_t | idx
| ) |  |

Transmits a DICOM annotation to the printer (Basic Annotation Box N-SET).

Parameters

  printHandler | print communication handler, association must be open.
  idx | index of the annotation from which the settings are taken, must be < getNumberOfAnnotations().

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ printSCUsetBasicImageBox()

OFCondition DVPSStoredPrint::printSCUsetBasicImageBox | ( | DVPSPrintMessageHandler & | printHandler,
|  | size_t | idx,
|  | DicomImage & | image,
|  | OFBool | useMonochrome1 = `OFFalse`
| ) |  |

Transmits a DICOM image to the printer (Basic Grayscale Image Box N-SET).

Parameters

  printHandler | print communication handler, association must be open.
  idx | index of the image reference from which the Image Box settings are taken, must be < getNumberOfImages().
  image | DICOM image to be printed
  useMonochrome1 | if true, the image is transmitted in MONOCHROME1 photometric interpretation. Default is false, image is transmitted in MONOCHROME2 in this case.

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ read()

OFCondition DVPSStoredPrint::read | ( | DcmItem & | dset | ) |

reads a Stored Print object from a DICOM dataset.

The DICOM elements of the stored print object are copied from the dataset to this object. The completeness of the object (presence of all required elements, value multiplicity) is checked. If this method returns an error code, the object is in undefined state afterwards.

Parameters

  dset | the dataset from which the data is to be read

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ replaceImageBox()

void DVPSStoredPrint::replaceImageBox | ( | DVPSImageBoxContent * | newImageBox | ) |
| inline

adds the given image box object to the image box list.

Any other object existing in the list with the same SOP instance UID is removed. Used during a Print SCP basic grayscale image box N-SET operation.

Parameters

  newImageBox | new image box object to be added to the list.

## ◆ setBorderDensity()

OFCondition DVPSStoredPrint::setBorderDensity | ( | const char * | value | ) |

sets the (optional) border density.

Parameters

  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setConfigurationInformation()

OFCondition DVPSStoredPrint::setConfigurationInformation | ( | const char * | value | ) |

sets the (optional) configuration information.

Parameters

  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setDefaultPresentationLUT()

OFCondition DVPSStoredPrint::setDefaultPresentationLUT | ( |  | ) |

resets the Presentation LUT to the default setting.

i.e. the presentation LUT which is specified separately for each image box is used.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setDestination()

OFCondition DVPSStoredPrint::setDestination | ( | const char * | aetitle | ) |

sets the application entity title of the print SCU.

Returns
  application entity title of the print SCU

## ◆ setEmtpyImageDensity()

OFCondition DVPSStoredPrint::setEmtpyImageDensity | ( | const char * | value | ) |

sets the (optional) empty image density.

Parameters

  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setFilmOrientation()

OFCondition DVPSStoredPrint::setFilmOrientation | ( | DVPSFilmOrientation | value | ) |

sets the (optional) film orientation.

Parameters

  value | new enumerated value. The caller is responsible for making sure that the selected printer supports film orientation if a non-default value is set.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setFilmSizeID()

OFCondition DVPSStoredPrint::setFilmSizeID | ( | const char * | value | ) |

sets the (optional) film size ID.

Parameters

  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setImageConfigurationInformation()

OFCondition DVPSStoredPrint::setImageConfigurationInformation | ( | size_t | idx,
|  | const char * | value
| ) |  |
| inline

sets the (optional) configuration information for the given registered image box.

Parameters

  idx | index, must be < getNumberOfImages()
  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setImageDisplayFormat()

OFCondition DVPSStoredPrint::setImageDisplayFormat | ( | unsigned long | columns,
|  | unsigned long | rows
| ) |  |

sets the image display format to 'STANDARD\columns,rows'.

The caller must make sure that the column and row values are valid for the selected printer.

Parameters

  columns | number of columns
  rows | number of rows

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setImageMagnificationType()

OFCondition DVPSStoredPrint::setImageMagnificationType | ( | size_t | idx,
|  | const char * | value
| ) |  |
| inline

sets the (optional) magnification type for the given registered image box.

Parameters

  idx | index, must be < getNumberOfImages()
  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setImagePolarity()

OFCondition DVPSStoredPrint::setImagePolarity | ( | size_t | idx,
|  | const char * | value
| ) |  |
| inline

sets the polarity for the given registered image box.

Parameters

  idx | index, must be < getNumberOfImages()
  value | new attribute value (NORMAL or REVERSE), may be NULL.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setImageRequestedSize()

OFCondition DVPSStoredPrint::setImageRequestedSize | ( | size_t | idx,
|  | const char * | value
| ) |  |
| inline

sets the requested size for the given registered image box.

Parameters

  idx | index, must be < getNumberOfImages()
  value | new attribute value (in mm), may be NULL.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setImageSmoothingType()

OFCondition DVPSStoredPrint::setImageSmoothingType | ( | size_t | idx,
|  | const char * | value
| ) |  |
| inline

sets the (optional) smoothing type for the given registered image box.

Parameters

  idx | index, must be < getNumberOfImages()
  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setInstanceUID()

OFCondition DVPSStoredPrint::setInstanceUID | ( | const char * | uid | ) |

sets a new SOP Instance UID for the Stored Print object.

Parameters

  uid | new SOP Instance UID

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setMagnificationType()

OFCondition DVPSStoredPrint::setMagnificationType | ( | const char * | value | ) |

sets the (optional) magnification type.

Parameters

  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setMaxDensity()

OFCondition DVPSStoredPrint::setMaxDensity | ( | const char * | value | ) |

sets the (optional) max density.

Parameters

  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setMinDensity()

OFCondition DVPSStoredPrint::setMinDensity | ( | const char * | value | ) |

sets the (optional) min density.

Parameters

  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setOriginator()

OFCondition DVPSStoredPrint::setOriginator | ( | const char * | aetitle | ) |

sets the name of the current printer.

This name is identical to the unique entry used in the configuration file.

Returns
  name of the current printer

## ◆ setPresentationLookupTable()

OFCondition DVPSStoredPrint::setPresentationLookupTable | ( | DcmItem & | dset | ) |

stores a presentation lookup table in the stored print object.

This method stores a presentation lookup table in the stored print object and activates it. This LUT overrides the settings made for the individual image boxes. If unsuccessful, LUT is not set.

Parameters

  dset | dataset from which the Presentation LUT SQ or Shape is read.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setPresentationLUTShape()

OFCondition DVPSStoredPrint::setPresentationLUTShape | ( | DVPSPresentationLUTType | shape | ) |

sets the current Presentation LUT shape (overrides the image box settings).

Only DVPSP_identity and DVPSP_lin_od are allowed.

Parameters

  shape | the new presentation LUT shape.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setPrinterName()

OFCondition DVPSStoredPrint::setPrinterName | ( | const char * | name | ) |

sets the application entity title of the print SCP.

Returns
  application entity title of the print SCP

## ◆ setPrintIllumination()

OFCondition DVPSStoredPrint::setPrintIllumination | ( | Uint16 | value | ) |

sets the illumination to be used with the print Presentation LUT SOP Class.

Parameters

  value | new attribute value, in cd/m2. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setPrintReflectedAmbientLight()

OFCondition DVPSStoredPrint::setPrintReflectedAmbientLight | ( | Uint16 | value | ) |

sets the reflected ambient light to be used with the print Presentation LUT SOP Class.

Parameters

  value | new attribute value, in cd/m2. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setRequestedDecimateCropBehaviour()

OFCondition DVPSStoredPrint::setRequestedDecimateCropBehaviour | ( | DVPSDecimateCropBehaviour | value | ) |

sets the (optional) requested decimate/crop behaviour for all image boxes managed by this stored print object.

Parameters

  value | new enumerated value. The caller is responsible for making sure that the selected printer supports decimate/crop if a non-default value is set.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setResolutionID()

OFCondition DVPSStoredPrint::setResolutionID | ( | const char * | value | ) |

sets the (optional) requested resolution ID.

Parameters

  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setSingleAnnotation()

OFCondition DVPSStoredPrint::setSingleAnnotation | ( | const char * | displayformat,
|  | const char * | text,
|  | Uint16 | position
| ) |  |

deletes all existing annotations and creates a new one, with given text and position.

Sets annotation display format to the given value.

Parameters

  displayformat | annotation display format
  text | annotation text
  position | annotation position

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setSmoothingType()

OFCondition DVPSStoredPrint::setSmoothingType | ( | const char * | value | ) |

sets the (optional) smoothing type.

Parameters

  value | new attribute value, may be NULL. The caller is responsible for making sure that the value is valid for the selected printer.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ setTrim()

OFCondition DVPSStoredPrint::setTrim | ( | DVPSTrimMode | value | ) |

sets the (optional) trim (printing of borders).

Parameters

  value | new enumerated value. The caller is responsible for making sure that the selected printer supports trim if a non-default value is set.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ updatePresentationLUTList()

void DVPSStoredPrint::updatePresentationLUTList | ( | DVPSPresentationLUT_PList & | globalPresentationLUTList | ) |

updates the list of Presentation LUTs managed by the Stored Print object from a global list.

If a Presentation LUT is active on Film Box level, the corresponding LUT is copied from the global presentation LUT list. Presentation LUT references on Image Box level are ignored. Used during a Print SCP N-ACTION operation.

Parameters

  globalPresentationLUTList | list of presentation LUTs managed by the Print SCP

## ◆ usesPresentationLUT()

OFBool DVPSStoredPrint::usesPresentationLUT | ( | const char * | c | ) |

checks whether the Presentation LUT with the given UID is referenced by this Stored Print object on the film box level.

Presentation LUT references on Image Box level are ignored.

Parameters

  c | uid to be compared

Returns
  OFTrue if equal, OFFalse otherwise

## ◆ write()

OFCondition DVPSStoredPrint::write | ( | DcmItem & | dset,
|  | OFBool | writeRequestedImageSize,
|  | OFBool | limitImages,
|  | OFBool | updateDecimateCrop,
|  | OFBool | ignoreEmptyImages
| ) |  |

writes the Stored Print object to a DICOM dataset.

Copies of the DICOM elements managed by this object are inserted into the DICOM dataset.

Parameters

  dset | the dataset to which the data is written
  writeRequestedImageSize | if false, the Requested Image Size attributes are not written, e. g. because they are not supported by the target printer.
  limitImages | if true, only the number of image references that are needed for the current image display format (film layout) are written. If false, all image references are written.
  updateDecimateCrop | if true, the decimate/crop attribute on image box level is replaced by the global stored print level setting in all image boxes prior to writing the dataset.
  ignoreEmptyImages | if true, all image boxes without image box position are ignored when writing.

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ writeHardcopyImageAttributes()

OFCondition DVPSStoredPrint::writeHardcopyImageAttributes | ( | DcmItem & | dset | ) |

writes the general study and series module attributes for a grayscale hardcopy image that is related to this stored print object to a DICOM dataset.

Copies of the DICOM elements managed by this object are inserted into the DICOM dataset.

Parameters

  dset | the dataset to which the data is written

Returns
  EC_Normal if successful, an error code otherwise.

## Member Data Documentation

## ◆ presentationLUTInstanceUID

OFString DVPSStoredPrint::presentationLUTInstanceUID
| private

the current presentation LUT instance.

If used as Print SCU, the content of this string can differ from referencedPresentationLUTInstanceUID which contains the UID from the Stored Print object whereas this string contains the UID assigned by the remote Print SCP. If used as Print SCP, these strings should always be equal.

## ◆ referencedPresentationLUTAlignment

DVPSPrintPresentationLUTAlignment DVPSStoredPrint::referencedPresentationLUTAlignment
| private

The Print SCP can be configured to enforce a rule requiring that the number of entries in a Presentation LUT matches the bit depth of the image pixel data.

This member variable describes the type of the current presentation LUT (if any).

The documentation for this class was generated from the following file:

- dcmpstat/include/dcmtk/dcmpstat/dvpssp.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1